<?php
error_reporting(0);
// Version
define('VERSION', '1.5.5.1');

// Configuration
if (file_exists('../admin/config.php')) {
	require_once('../admin/config.php');
}  

// Startup
require_once(DIR_SYSTEM . 'startup.php');

// Application Classes
require_once(DIR_SYSTEM . 'library/customer.php');
require_once(DIR_SYSTEM . 'library/affiliate.php');
require_once(DIR_SYSTEM . 'library/currency.php');
require_once(DIR_SYSTEM . 'library/tax.php');
require_once(DIR_SYSTEM . 'library/weight.php');
require_once(DIR_SYSTEM . 'library/length.php');
require_once(DIR_SYSTEM . 'library/cart.php');

// Registry
$registry = new Registry();

// Loader
$loader = new Loader($registry);
$registry->set('load', $loader);

// Config
$config = new Config();
$registry->set('config', $config);


// Database 
$db = new DB(DB_DRIVER, DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, DB_DATABASE);
$registry->set('db', $db);

// Store
if (isset($_SERVER['HTTPS']) && (($_SERVER['HTTPS'] == 'on') || ($_SERVER['HTTPS'] == '1'))) {
	$store_query = $db->query("SELECT * FROM " . DB_PREFIX . "store WHERE REPLACE(`ssl`, 'www.', '') = '" . $db->escape('https://' . str_replace('www.', '', $_SERVER['HTTP_HOST']) . rtrim(dirname($_SERVER['PHP_SELF']), '/.\\') . '/') . "'");
} else {
	$store_query = $db->query("SELECT * FROM " . DB_PREFIX . "store WHERE REPLACE(`url`, 'www.', '') = '" . $db->escape('http://' . str_replace('www.', '', $_SERVER['HTTP_HOST']) . rtrim(dirname($_SERVER['PHP_SELF']), '/.\\') . '/') . "'");
}

if ($store_query->num_rows) {
	$config->set('config_store_id', $store_query->row['store_id']);
} else {
	$config->set('config_store_id', 0);
}
		
// Settings
$query = $db->query("SELECT * FROM " . DB_PREFIX . "setting WHERE store_id = '0' OR store_id = '" . (int)$config->get('config_store_id') . "' ORDER BY store_id ASC");

foreach ($query->rows as $setting) {
	if (!$setting['serialized']) {
		$config->set($setting['key'], $setting['value']);
	} else {
		$config->set($setting['key'], unserialize($setting['value']));
	}
}

if (!$store_query->num_rows) {
	$config->set('config_url', HTTP_SERVER);
	$config->set('config_ssl', HTTPS_SERVER);	
}

// Url
$url = new Url($config->get('config_url'), $config->get('config_secure') ? $config->get('config_ssl') : $config->get('config_url'));	
$registry->set('url', $url);

// Log 
$log = new Log($config->get('config_error_filename'));
$registry->set('log', $log);

function error_handler($errno, $errstr, $errfile, $errline) {
	return true;
}
	
// Error Handler
set_error_handler('error_handler');



  define('WP_USE_THEMES', false);
  define('__ENCODE_RESPONSE', true);

  define('__DEBUG', 1);
  define('__LANGUAGE_ID', 1);
  define('__DELIVERED_STATUS_ID', '4'); // Delivered
  define('__DELIVERED_STATUS_NAME', 'Delivered');

  define('__PROCESSING_STATUS_ID', '2');
  define('__PROCESSING_STATUS_NAME', 'Processing');

  define('__CLEARED_STATUS_ID', '3');
  define('__CLEARED_STATUS_NAME', 'CLEARED');
  define('__DECLINED_STATUS_ID', '6');
  define('__DECLINED_STATUS_NAME', 'DECLINE');
  define('__FRAUD_STATUS_ID', '6');
  define('__FRAUD_STATUS_NAME', 'FRAUD');
  define('__PENDING_STATUS_ID', '2');
  define('__PENDING_STATUS_NAME', 'PENDING');

//  DEFINE('', false);
  define('__MAX_NUMBER_OF_OPTIONVALUES', 300);
  define('__STATUS_MESSAGE_MAX_LENGTH',500);
  define('__USERID_MAX_LENGTH',75);
  define('__PASSWORD_MAX_LENGTH',15);
  define('__COMMAND_MAX_LENGTH',15);

  define('STATUSNOTINLIST','1,6');



  require('thubxml.php');



  $default_vendor = 1;  // for store info
  global $ps_vendor_id,  $category_id,$itemCategory,
                        $itemManufacturer,$manufacturer_id,
                        $_err_message_arr,$item;
  global $mosConfig_absolute_path;

  $category_id=0;
  $manufacturer_id=0;
  $_err_message_arr=array();
  $ps_vendor_id=1;

 if (!isset($request_)) {
    if (isset($_POST)){
      $request_ = $_POST['request'];
      }
    else{
      $request_ = $HTTP_POST_VARS['request'];
      }
  }

    if (empty($request_)){
      exit;
    }

  // parse XML Request
    $request_ = trim(stripcslashes($request_));
    $xmlRequest = new xml_doc($request_);
	
    $xmlRequest->parse();

    $xmlRequest->getTag(0, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);

    $db2 = $db;
    $db3 = $db;


    if (strtoupper(trim($_tagName)) != 'REQUEST') {
        print(xmlErrorResponse('unknown', '9999-2',
                'Unknown request', STORE_NAME, ''));
        flush;exit;
    }
    if (count($_tagTags) == 0) {
        print(xmlErrorResponse('unknown', '9999-3',
                'REQUEST tag doesnt have necessry parameters', STORE_NAME, ''));
        flush;exit;
    }

    $RequestParams = Array();
    foreach ($_tagTags as $k=>$v){
        $xmlRequest->getTag($v, $tN, $tA, $tC, $tT);
        $RequestParams[strtoupper($tN)] = trim($tC);
    }

	if (!isset($RequestParams['COMMAND'])) {
        print(xmlErrorResponse('unknown', '9999-4',
                'Command is not set', STORE_NAME, ''));
        exit;
	}



    $RequestParams['COMMAND'] = strtoupper($RequestParams['COMMAND']);
	
	

  // print($RequestParams['COMMAND']);
    if(  ($RequestParams['COMMAND'] != ('GET'.'ORDERS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'INVENTORY'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'.'SHIPPING'.'STATUS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'.'PAYMENT'.'STATUS'))){
          print(xmlErrorResponse('unknown', '9999-5',
                  'Unknown Command'.$RequestParams['COMMAND'], STORE_NAME, ''));
          exit;
     }

	if (isset($RequestParams['REQUESTID'])) $request_id = $RequestParams['REQUESTID'];

  // check for installed admin auth contribution and do authentification.
    if (!isset($RequestParams['USERID'])||empty($RequestParams['USERID']))     {
    	print(xmlErrorResponse($RequestParams['COMMAND'], '9999-6',
    	        'UserID field is not set', STORE_NAME, ''));
    	exit;
    }
    $UserID = $RequestParams['USERID'];
    if (strlen($UserID)>__USERID_MAX_LENGTH){
    	print(xmlErrorResponse($RequestParams['COMMAND'], '9999-7',
    	        'Field UserID more maximum value', STORE_NAME, ''));
    	exit;
    }

    if (!isset($RequestParams['PASSWORD'])||empty($RequestParams['PASSWORD']))   {
    	print(xmlErrorResponse($RequestParams['COMMAND'], '9999-8',
    	        'Password field is not set', STORE_NAME, ''));
    	exit;
    }
 $Password = $RequestParams['PASSWORD']; 
    if (strlen($Password)>__PASSWORD_MAX_LENGTH){
    	print(xmlErrorResponse($RequestParams['COMMAND'], '9999-9',
    	        'Field Password more maximum value', STORE_NAME, ''));
    	exit;
    }
	
$user_query = $db->query("SELECT * FROM " . DB_PREFIX . "user WHERE username = '" . $db->escape($UserID) . "' AND (password = SHA1(CONCAT(salt, SHA1(CONCAT(salt, SHA1('" . $db->escape($Password) . "'))))) OR password = '" . $db->escape(md5($Password)) . "') AND status = '1'");
	if (!$user_query->num_rows){
        print(xmlErrorResponse($RequestParams['COMMAND'], '9000',
            '1. Order download service authentication failure - Login/Password supplied did not match['.$q.']', STORE_NAME, ''));
        flush;exit;
	}

	define(QB_PROVIDER, $RequestParams['PROVIDER']);



	if (isset($RequestParams['LIMITORDERCOUNT'])&&(int)$RequestParams['LIMITORDERCOUNT']!=0){
		define(QB_ORDERS_PER_RESPONSE, $RequestParams['LIMITORDERCOUNT']);
		$sql_limit_order_count=" LIMIT 0,".(string)(int)QB_ORDERS_PER_RESPONSE;
    }
	else{
    	define(QB_ORDERS_PER_RESPONSE, 25);
		$sql_limit_order_count=" LIMIT 0,25";
    }
    $filter_order_start_number="";
	if (isset($RequestParams['ORDERSTARTNUMBER'])){
  	    define(QB_ORDER_START_NUMBER, $RequestParams['ORDERSTARTNUMBER']);
	    if(QB_ORDER_START_NUMBER>0){
	    	$filter_order_start_number=" AND o.id>=".QB_ORDER_START_NUMBER;
		}
    	else{
            define(QB_ORDER_START_NUMBER, 0);
	    }
    }
	else{
        define(QB_ORDER_START_NUMBER, 0);
	}
	if(QB_ORDER_START_NUMBER==0){
    	if (isset($RequestParams['NUMBEROFDAYS'])){
	        define(QB_NUMBER_OF_DAYS, $RequestParams['NUMBEROFDAYS']);
    		$date= mktime(0,0,0,date("m"),date("d")-QB_NUMBER_OF_DAYS+1,date("Y"));
	    	$filter_order_start_number=" AND o.date>'".(string)$date."'";
        }
	    else{
	        define(QB_NUMBER_OF_DAYS, $RequestParams['NUMBEROFDAYS']);
	    	$filter_order_start_number=" AND o.id>".QB_ORDER_START_NUMBER;

	    }
    }


	$xmlResponse = new xml_doc();
	$xmlResponse->version='1.0';
	$xmlResponse->encoding='ISO-8859-1';

	$root = $xmlResponse->createTag("RESPONSE", array('Version'=>'4.0'));
	$envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
	$xmlResponse->createTag("Command", array(), $RequestParams['COMMAND'], $envelope);

     switch ($RequestParams['COMMAND']){

    //***************************************************
    //
    //      get  Orders Service
    //
    //***************************************************

        case 'GETORDERS' : {
			//echo "<pre>";
		//	print_r($RequestParams);
			$loader->model('thub/api');
			$model = $registry->get('model_thub_api');
			$date_modf=explode(" ",$RequestParams['DOWNLOADSTARTDATE']);
			$startDateArray = explode('-',$date_modf[0]);
			if(is_array($startDateArray) && count($startDateArray)>1){
				list($sy,$sm,$sd) = explode('-',$date_modf[0]);
			}
			else{
				list($sm,$sd,$sy) = explode('/',$date_modf[0]);
			}
			
			$startDate = date("Y-m-d H:i:s",strtotime($sy."-".$sm."-".$sd." ".$date_modf[1]." ".$date_modf[2]));

			
			//$data=array("filter_date_modified1"=>$startDate,"limit"=>$RequestParams['LIMITORDERCOUNT'],"order_start_number"=>$RequestParams['ORDERSTARTNUMBER']);
			$data=array("filter_date_modified1"=>$startDate,"limit"=>$RequestParams['LIMITORDERCOUNT']);
			$row = $model->getOrders($data);

            if (count($row)==0){ // 
                print(xmlErrorResponse($RequestParams['COMMAND'], '1000',
                    'No Orders returned', STORE_NAME, ''));
                flush;exit;
            }

        	$xmlResponse->createTag("StatusCode", array(), "0", $envelope);
        	$xmlResponse->createTag("StatusMessage", array(), "All OK", $envelope);
        	$xmlResponse->createTag("Provider", array(), QB_PROVIDER, $envelope);

            $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
			
			
            foreach($row as $val){
				
				
				$totalNdiscount = $model->getTotalNDiscounts($val['order_id']);
				//$orderComment = $model->getOrderHistory($val['order_id']);
				$shippingValue = "";
				$shippingMethodName = "";
				$DiscountValue = "";
				$TotalValue = "";
				$taxValue = "";
				$comments = "";
				if($val['comment']!=''){
					$comments = $val['comment'];
				}
				
				foreach($totalNdiscount as $key => $value){
					$value['code'];	
					if($value['code']=='shipping'){
						$shippingValue = round($value["value"],2);
						$shippingMethodName = $value["title"];
					}
					if($value['code']=='total'){
						$TotalValue = round($value["value"],2);
					}
					if($value['code']=='coupon'){
						$DiscountValue = round(str_replace("-","",$value["value"]),2);
					}
					if($value['code']=='tax'){
						$taxValue = round($value["value"],2);
					}
					
				}

				
                $orderNode = $xmlResponse->createTag("Order", array(), '', $ordersNode );
                $xmlResponse->createTag("OrderID",          array(), $val['order_id'], $orderNode );
                $xmlResponse->createTag("ProviderOrderRef", array(), $val['order_id'],$orderNode );
                $xmlResponse->createTag("Date",             array(), date("Y-m-d",strtotime($val['date_modified'])),$orderNode );
                $xmlResponse->createTag("Time",             array(), date("H:i:s",strtotime($val['date_modified'])),$orderNode );
				$xmlResponse->createTag("UpdatedOn",        array(), date("Y-m-d H:i:s",strtotime($val['date_modified'])),$orderNode );
                $xmlResponse->createTag("TimeZone",         array(), 'PST',                        $orderNode, '');
                $xmlResponse->createTag("StoreId",          array(), 'OpenCart',          $orderNode);
                $xmlResponse->createTag("StoreName",        array(), 'OpenCart',  $orderNode, '');
                $xmlResponse->createTag("CustomerID",       array(), $val['customer_id'],            $orderNode);
                $xmlResponse->createTag("SalesRep",         array(), "",                           $orderNode, '');
                $xmlResponse->createTag("Comment",          array(),$comments,    $orderNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Currency",         array(), $val['currency_code'],    $orderNode, '');
				$xmlResponse->createTag("TransactionId",         array(), '',    $orderNode, '');				


                $BillNode = $xmlResponse->createTag("Bill", array(), "", $orderNode);
                $ShipNode  = $xmlResponse->createTag("Ship",    array(), '', $orderNode);
				$ChargesNode  = $xmlResponse->createTag("Charges",    array(), '', $orderNode);


			$orderStatus = array(7=>"Canceled",9=>"Canceled Reversal",13=>"Chargeback",5=>"Complete",8=>"Denied",14=>"Expired",10=>"Failed",1=>"Pending",15=>"Processed",2=>"Processing",11=>"Refunded",12=>"Reversed",3=>"Shipped",16=>"Voided");
			
            $xmlResponse->createTag("PayStatus",array(), $orderStatus[$val['order_status_id']],   $BillNode);



                $xmlResponse->createTag("PayMethod",        array(), $val['payment_method'],$BillNode, '');

                $xmlResponse->createTag("FirstName", array(), _maxlen($val['payment_firstname'],45), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("LastName", array(), _maxlen($val['payment_lastname'],45), $BillNode, __ENCODE_RESPONSE);

                $xmlResponse->createTag("MiddleName", array(), '', $BillNode, __ENCODE_RESPONSE);


                $xmlResponse->createTag("CompanyName", array(), '', $BillNode, '');
                $xmlResponse->createTag("Address1", array(), $val['payment_address_1'], $BillNode, __ENCODE_RESPONSE);
				
				
				$xmlResponse->createTag("Address2", array(), '', $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("City", array(), _maxlen($val['payment_city'],75), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("State", array(), htmlentities((isset($val['payment_zone'])) ? $val['payment_zone'] : ''), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Zip", array(), $val['payment_postcode'], $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Country", array(), _maxlen($val['payment_country'],75), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Email", array(), _maxlen($val['email'],150), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Phone", array(), _maxlen($val['telephone'],15), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("PONumber", array(), '', $BillNode, '');
				$xmlResponse->createTag("ShipDate", array(), '', $ShipNode, '');
				$xmlResponse->createTag("ShipCost", array(), '', $ShipNode, '');
				$xmlResponse->createTag("ShipCarrierName", array(), "", $ShipNode, '');
				$xmlResponse->createTag("ShipMethod", array(), $shippingMethodName, $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("Tracking", array(), "", $ShipNode, '');				
				$shipStatus = "New";
				
				$xmlResponse->createTag("ShipStatus", array(), $shipStatus, $ShipNode, '');

				$xmlResponse->createTag("FirstName", array(), _maxlen($val['shipping_firstname'],45), $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("LastName", array(), _maxlen($val['shipping_lastname'],45), $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("MiddleName", array(), '', $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("CompanyName", array(), $val['shipping_company'], $ShipNode, __ENCODE_RESPONSE);
				
				
				
						
				
				$xmlResponse->createTag("Address1", array(), _maxlen($val['shipping_address_1'],75), $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("Address2", array(), $val['shipping_address_2'], $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("City", array(), _maxlen($val['shipping_city'],75), $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("State", array(), htmlentities((isset($val['shipping_zone'])) ? $val['payment_zone'] : ''), $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("Zip", array(), $val['shipping_postcode'], $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("Country", array(), _maxlen($val['shipping_country'],75), $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("Email", array(), _maxlen($val['email'],150), $ShipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("Phone", array(), _maxlen($val['telephone'],15), $ShipNode, __ENCODE_RESPONSE);

			   
//             Block containing Items in Orders
               $ItemsNode=$xmlResponse->createTag("Items",array(),"" , $orderNode );
//             Block containing Item in Items

       
			
				$itemDetails = $model->getOrderProducts($val['order_id']);    
			      

			  	$totalItemPrice = 0;

                foreach($itemDetails as $value){
                    $ItemNode=$xmlResponse->createTag("Item",array(),"" , $ItemsNode );
                    $xmlResponse->createTag("ItemCode",array(),$value['model'], $ItemNode );
                 
				 
					$order_options = $model->getOrderOptions($val['order_id'], $value['order_product_id']);
					
					$options = array();
					$_description = $value['name']."\n";
					//foreach ($order_options as $option) {
					//	$_description .= $option['name']." - ".$option['value']."\n";
					//}				 
				 
					$xmlResponse->createTag("ItemDescription",array(),$_description, $ItemNode , __ENCODE_RESPONSE);
                    $xmlResponse->createTag("Quantity",array(),$value['quantity'], $ItemNode );
                    $xmlResponse->createTag("UnitPrice",array(),(float)$value['price'], $ItemNode );
					
					$xmlResponse->createTag("ItemUnitWeight",array(),$value['weight'], $ItemNode);	

                    $xmlResponse->createTag("ItemTotal",array(),(float)$value['total'], $ItemNode );
                    
                        
                    $xmlResponse->createTag("CustomField1",array(),"" , $ItemNode , '');
                    $xmlResponse->createTag("CustomField2",array(),"" , $ItemNode , '');
                    $xmlResponse->createTag("CustomField3",array(),"" , $ItemNode , '');
                    $xmlResponse->createTag("CustomField4",array(),"" , $ItemNode , '');
                    $xmlResponse->createTag("CustomField5",array(),"" , $ItemNode , '');


                    if (!isset($itemOptionsNode)) $itemOptionsNode  = $xmlResponse->createTag("ItemOptions",    array(), '',     $ItemNode, '');
										//
										// Data is stored in DB as 
										// Color: Black<br/> Size: 1 (XS/S)
										//
										
					foreach ($order_options as $option) {
						$xmlResponse->createTag("ItemOption", array('Name'=> $option['name'],'Value'=>$option['value']),'',$itemOptionsNode, '');
					}	

                    unset($itemOptionsNode);


                }

				$purchlogitem->totalAmount = $totalItemPrice;
				$xmlResponse->createTag("Shipping", array(), (float)$shippingValue, $ChargesNode, '');
				$xmlResponse->createTag("Handling", array(), "", $ChargesNode, '');
				$xmlResponse->createTag("Tax", array(), (float)$taxValue, $ChargesNode, '');
				$xmlResponse->createTag("Discount", array(), (float)$DiscountValue, $ChargesNode, '');
				$xmlResponse->createTag("Total", array(), (float)$TotalValue, $ChargesNode, '');

                $is_tax = false;
                $is_shipping = false;
                $is_total = false;
                $is_discount = false;

                $xmlResponse->createTag("CustomField1",array(),"" , $orderNode , '');
                $xmlResponse->createTag("CustomField2",array(),"" , $orderNode , '');
                $xmlResponse->createTag("CustomField3",array(),"" , $orderNode , '');
                $xmlResponse->createTag("CustomField4",array(),"" , $orderNode , '');
                $xmlResponse->createTag("CustomField5",array(),"" , $orderNode , '');
            }

        }  break;


        case 'UPDATEORDERSSHIPPINGSTATUS' : {

			$ordersTag = $xmlRequest->getChildByName(0, "ORDERS");
			$xmlRequest->getTag($ordersTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
			if (count($_tagTags) == 0)  $no_orders = true; else $no_orders = false;
			$xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
			$xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
			if ($no_orders){
    		    print($xmlResponse->generate()); exit;
			}

			$ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
			foreach($_tagTags as $k=>$v){
			    $order = Array();
				$xmlRequest->getTag($v, $_tagName, $_tagAttributes, $_tagContents, $_orderTags);
                $orderNode = $xmlResponse->createTag("Order",  array(), '',     $ordersNode);
                foreach($_orderTags as $k1=>$v1){
                    $xmlRequest->getTag($v1, $_tagName, $_tagAttributes, $_tagContents, $_tempTags);
                    $order[strtoupper($_tagName)] = $_tagContents;
                    if (strtoupper($_tagName)=='HOSTORDERID')
                        $xmlResponse->createTag('HostOrderID',  array(), $_tagContents,     $orderNode);
                    if (strtoupper($_tagName)=='LOCALORDERID')
                        $xmlResponse->createTag('LocalOrderID',  array(), $_tagContents,     $orderNode);
			    }
    		    
				$result = 'Failed';
				
				$loader->model('thub/api');
				$model = $registry->get('model_thub_api');
				$row = $model->getOrder($order['HOSTORDERID']);

                $arrdate=explode("/", $order['SHIPPEDON']);
				
				
				
				$shippedOn = $order['SHIPPEDON']; //3/26/2013
				$shippedVia = $order['SHIPPEDVIA']; //UPS
				$serviceUsed = $order['SERVICEUSED']; //2nd Day Air
				$trackingNo = $order['TRACKINGNUMBER']; //5Z44444444
				$notifyCustomer = $order['NOTIFYCUSTOMER']; //yes
				
				
				$data = array();
                if(!empty($row)){
						$dataArr = array("shipping_method"=>$order['SHIPPEDVIA']);
						$data['order_status_id'] = 3; //Shipped
						$data['notify'] = ($notifyCustomer=='yes') ? 1 : 0;
						if($shippedVia=='' && $serviceUsed==''){
							$data['comment'] = "Package Shipped on ".$shippedOn." Tracking No# ".$trackingNo;
						}
						else{
							$data['comment'] = "Package shipped on ".$shippedOn." via ".$shippedVia." ".$serviceUsed.". Tracking No ".$trackingNo;	
						}
						
						$model->addOrderHistory($order['HOSTORDERID'], $data);
						$result = 'Success';
					
				}
			    $xmlResponse->createTag('HostStatus',  array(), $result, $orderNode);
			}
		} break;  // end of update Orders Shipping Status Service


    }

    header("Content-type: application/xml");
    print($xmlResponse->generate());




function xmlErrorResponse($command, $code, $message, $provider, $request_id='') {
  header("Content-type: application/xml");
  $xmlResponse = new xml_doc('<?xml version="1.0" encoding="UTF-8"?>');
  //$xmlResponse = new xml_doc();
  //$xmlResponse->version='';
 // $xmlResponse->encoding='UTF-8';
  $root = $xmlResponse->createTag("RESPONSE", array('Version'=>'1.0'));
  //print("i'm here");
  $envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
  $xmlResponse->createTag("Command", array(), $command, $envelope);
  $xmlResponse->createTag("StatusCode", array(), $code, $envelope);
  $xmlResponse->createTag("StatusMessage", array(), _maxlen($message,__STATUS_MESSAGE_MAX_LENGTH), $envelope);
  //if ($request_id) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
  //$xmlResponse->createTag("Provider", array(), $provider, $envelope);
  return $xmlResponse->generate();
}


    function _maxlen($str,$len){

        if (strlen($str)>$len)
           return substr($str,0,$len);
        else
           return $str;
    }
	


?>
